#ifndef _RATING_H_
#define _RATING_H_


#include "board.h"
#include "pattern.h"
#include "mt19937p.h"


/* pI */
enum FEATURE {
	F_SAVE_CAPTURE,		
	F_SAVE_EXTENSION,
	F_CAPTURE,	
	F_CAPTURE_AFTER_KO,	
	F_SELF_ATARI,
	F_ATARI,
	F_2POINT_SEMEAI,
	F_MAX,
};

#define TACTICAL_FEATURE F_MAX
#define BORDER_DISTANCE_MAX	11		// 10 : 19/2
#define MOVE_DISTANCE_MAX	55		// 54 : 18+18+18		


/*------------------------------------------------------------------*/
/* \                                                           */
/*------------------------------------------------------------------*/

struct rate_set {
	float list[2];
};


/*-------------------------------------------------------------------*/
/* O[oϐ                                                    */
/*-------------------------------------------------------------------*/

/*  */
extern float tactical_features[TACTICAL_FEATURE];
extern float border_distance[BORDER_DISTANCE_MAX];
extern float move_distance_1[MOVE_DISTANCE_MAX];
extern float move_distance_2[MOVE_DISTANCE_MAX];
extern float pattern3[PATTERN3_MAX];
extern float diamond[DIAMOND_MAX];

/* Ւ[Ƃ̋̃[g */
extern float border_rate[BOARD_MAX];

/* l */
extern struct rate_set init_rate_set[BOARD_MAX];


/*------------------------------------------------------------------*/
/* ֐                                                             */
/*------------------------------------------------------------------*/

/*  */
void InitializeRating( void );

/* ݒ */
void ClearRate( struct game *game );

/* (Elo Rating) */
int RatingMove( struct game *game, int color, struct mt19937p *mt );

/* [eBO */
void Rating( struct game *game, int color );

/* [gvZ */
void UpdateRate( struct game *game, int pos, struct rate_set *rate_set );

/* ̔ */
void CheckFeatures( struct game *game, int color, struct rate_set *rate_set );

/* Capture after ko */
void CheckCaptureAfterKo( struct game *game, int color, struct rate_set *rate_set );

/* ȃA^ */
void CheckSelfAtari( struct game *game, int color, int pos, struct rate_set *rate_set );

/* g̔ */
void CheckCapture( struct game *game, int color, int pos, struct rate_set *rate_set );

/* A^̔ */
void CheckAtari( struct game *game, int color, int pos, struct rate_set *rate_set );

/* ǂݍ */
void InputGamma( void );

/* eLXg */
void InputTxtFLT( char *filename, float *ap, int array_size );

/* MoveDistance ǂݍ */
void InputMoveDistance( char *filename, float *ap );

/* Diamond Pattern ǂݍ */
void InputDiamond( char *filename );


#endif  /* _RATING_H_ */